#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "rebuild_as_list4xi.py">
#<abstract4xi abstract = "provides function rebuild_as_list4xi"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'rebuild_as_list4xi' ]
#" 
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                           
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    import array
    import queue
    from traceback import format_exc
    import copyreg         
except:
    pass
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import rebuild_as_list
except:
    print("rebuild_as_list4xi.py *** failed in from multiprocessing.managers import rebuild_as_list ***")
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi 
from time4xi import time4xi
#"
#/>

 

# ---------------------------------------------------------------------------------------------
#<function4xi function = "rebuild_as_list4xi" usage = "
#   ForkingPickler.register(view_type, rebuild_as_list)
#
#       for view_type in view_types:
#           ForkingPickler.register(view_type, rebuild_as_list)
#           import copyreg
#           copyreg.pickle(view_type, rebuild_as_list)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ---------------------------------------------------------------------------------------------
def rebuild_as_list4xi(obj):
    '''
    function given as parameter to ForkingPickler4Xi.register and to copyreg.pickle 
    ''' 
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------          
    class2print = "rebuild_as_list4xi"
    method2print = "rebuild_as_list4xi"

    # -----------------------------------------------------------------------------------------    
    # (Step 1/2)
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 1/2a) started" + "; rebuild-as-list4xi-started: " + str(rebuild_as_list4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/2b) passed" + "; object-passed-to-rebuild-as-list4xi: " + str(obj) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                  
               
    
    # -----------------------------------------------------------------------------------------    
    # (Step 2/2)
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 2/2) returning" + "; list-object-returning-by-rebuild-as-list4xi: " + str(list(obj)) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
            
     
    
    return list, (list(obj),)
    
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-none4xi.xml
#   reason-none4xi.xml
#   ace-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of rebuild_as_list4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

